1

Our parachain is running on the polkadot relaychain, when we upgrade the runtime, we're facing the following errors shown in the collator's logs:

2024-05-09 07:43:30.376  INFO tokio-runtime-worker cumulus-collator: [Parachain] Starting collation. relay_parent=0xffe02781fdd765791e8c653d8c4ffa1c153d4a387a574ae01f07e34d7aed18f1 at=0xb151dff0ff24fce352f1ba7c32a13882f3b96d7c920b5597011839941e3e4a8e
2024-05-09 07:43:30.378  INFO tokio-runtime-worker sc_basic_authorship::basic_authorship: [Parachain] 🙌 Starting consensus session on top of parent 0xb151dff0ff24fce352f1ba7c32a13882f3b96d7c920b5597011839941e3e4a8e    
2024-05-09 07:43:30.379 ERROR tokio-runtime-worker runtime::storage: [Parachain] Corrupted state at `[74, 231, 226, 86, 249, 46, 88, 136, 55, 45, 114, 243, 228, 219, 16, 3, 30, 147, 46, 208, 111, 136, 199, 163, 125, 124, 124, 63, 95, 190, 202, 28, 51, 163, 180, 171, 112, 56, 53, 70, 222, 3, 99, 186, 106, 140, 134, 250, 153, 228, 177, 38, 135, 176, 17, 210, 52, 56, 242, 186, 7, 23, 218, 140]: Error`    
2024-05-09 07:43:30.379 ERROR tokio-runtime-worker frame_support::storage::generator::map: [Parachain] Invalid translate: fail to decode old value    
2024-05-09 07:43:30.380 ERROR tokio-runtime-worker frame_support::storage: [Parachain] (key, value) failed to decode at [74, 231, 226, 86, 249, 46, 88, 136, 55, 45, 114, 243, 228, 219, 16, 3, 230, 232, 254, 200, 40, 147, 138, 89, 205, 38, 7, 168, 208, 101, 25, 183, 93, 125, 138, 233, 68, 239, 77, 93, 157, 157, 130, 88, 158, 102, 109, 38, 0, 1, 2, 0, 109, 31, 6, 3, 101, 113, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]: Error    
2024-05-09 07:43:30.380 ERROR tokio-runtime-worker frame_support::storage: [Parachain] (key, value) failed to decode at [74, 231, 226, 86, 249, 46, 88, 136, 55, 45, 114, 243, 228, 219, 16, 3, 45, 180, 113, 224, 169, 111, 192, 132, 6, 35, 71, 190, 89, 234, 152, 118, 93, 125, 138, 233, 68, 239, 77, 93, 157, 157, 130, 88, 158, 102, 109, 38, 0, 1, 2, 0, 109, 31, 6, 3, 101, 113, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]: Error    
2024-05-09 07:43:30.380 ERROR tokio-runtime-worker runtime::storage: [Parachain] Corrupted state at `[69, 50, 61, 247, 204, 71, 21, 11, 57, 48, 226, 102, 107, 10, 163, 19, 197, 34, 35, 24, 128, 35, 138, 12, 86, 2, 27, 135, 68, 160, 7, 67]: Error`    
2024-05-09 07:43:30.383 ERROR tokio-runtime-worker runtime: [Parachain] panicked at /root/.cargo/git/checkouts/polkadot-sdk-cff69157b985ed76/c8d2251/cumulus/pallets/parachain-system/src/lib.rs:595:18:
Invalid messaging state in relay chain state proof: RelayDispatchQueueRemainingCapacity(Proof)    
2024-05-09 07:43:30.384  WARN tokio-runtime-worker sp_state_machine::overlayed_changes::changeset: [Parachain] 1 storage transactions are left open by the runtime. Those will be rolled back.    
2024-05-09 07:43:30.384  WARN tokio-runtime-worker sp_state_machine::overlayed_changes::changeset: [Parachain] 1 storage transactions are left open by the runtime. Those will be rolled back.   
2024-05-09 07:43:30.384  WARN tokio-runtime-worker sc_basic_authorship::basic_authorship: [Parachain] ❗ Inherent extrinsic returned unexpected error: Error at calling runtime api: Execution failed: Execution aborted due to trap: wasm trap: wasm `unreachable` instruction executed
WASM backtrace:

    0: 0x3de51e - <unknown>!rust_begin_unwind
    1: 0x4706 - <unknown>!core::panicking::panic_fmt::h87755523850ece9e
    2: 0x52e0 - <unknown>!core::result::unwrap_failed::hd86007cff22dcd83
    3: 0xdf857 - <unknown>!frame_support::storage::transactional::with_transaction::he3e0923a21dcd1a9
    4: 0x29063a - <unknown>!<cumulus_pallet_parachain_system::pallet::Call<T> as frame_support::traits::dispatch::UnfilteredDispatchable>::dispatch_bypass_filter::{{closure}}::h72d608a503d26f22
    5: 0x2a0831 - <unknown>!frame_support::dispatch_context::run_in_context::h64187430d7dbb8a2
    6: 0x5fe74 - <unknown>!<crust_parachain_runtime::RuntimeCall as frame_support::traits::dispatch::UnfilteredDispatchable>::dispatch_bypass_filter::h1906778505a13a0f
    7: 0x64e14 - <unknown>!<crust_parachain_runtime::RuntimeCall as sp_runtime::traits::Dispatchable>::dispatch::h9d655febc6c3ef1f
    8: 0x1c0104 - <unknown>!frame_executive::Executive<System,Block,Context,UnsignedValidator,AllPalletsWithSystem,COnRuntimeUpgrade>::apply_extrinsic::h6eac6b6ca11908d8
    9: 0x2f8872 - <unknown>!BlockBuilder_apply_extrinsic
. Dropping.    
2024-05-09 07:43:30.384 ERROR tokio-runtime-worker runtime: [Parachain] panicked at /root/.cargo/git/checkouts/polkadot-sdk-cff69157b985ed76/c8d2251/cumulus/pallets/parachain-system/src/lib.rs:248:13:
set_validation_data inherent needs to be present in every block!    

The collator binary is based on polkadot-sdk v0.9.29

The runtime to upgrade is based on polkadot-sdk v1.1.0

1 Answer 1

0

The collator binary is based on polkadot-sdk v0.9.29

The problem is that the collator binary is too old. Upgrade it to the same version as you use for the runtime and then the issue should be fixed.

The collator is not putting all the required data into the proof that it passes to the parachain runtime. This makes the parachain panic with the error you have posted.

3
  • You're right. Upgrade the collator binary to v1.1.0 do fix the problem, but require to re-sync all the DB data, since upgrade the collator binary from v0.9.29 to v1.1.0 would fail at db migration, seems the db format is not compatible between these two versions.
    – Brian Wu
    Commented May 11 at 6:10
  • Hmm should also not happen. We have migrations for DB changes.
    – bkchr
    Commented May 12 at 22:14
  • This is the error logs shown when I upgrade the collator binary from v0.9.29 to v1.1.0: INF0 main parachain::db: [Relaychain] Migrating parachains db from version 1 to version 2 ... INFO main parachain::db: [Relaychain] Migration complete! WARN tokio-runtime-worker sc service::builder: [Relaychain] The Networkstart returned as part of "build network’ has been silently dropped Error: service(Application(Application(Io(custom { kind: other, error: Error { message: "Invalid argument: column families not opened: col5,o14,col3,col2,col1,colo"}}))))
    – Brian Wu
    Commented May 13 at 1:40

Your Answer

By clicking “Post Your Answer”, you agree to our terms of service and acknowledge you have read our privacy policy.

Not the answer you're looking for? Browse other questions tagged or ask your own question.